package de.projektarbeit.can_monitor;

import de.projektarbeit.fragment.DataLogger_Fragment;
import de.projektarbeit.fragment.Tacho_Fragment;
import de.projektarbeit.fragment.Overview_Fragment;
import android.app.ActionBar;
import android.app.Activity;
import android.app.Fragment;
import android.app.FragmentTransaction;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.util.Log;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.widget.Toast;


public class CAN_Monitor_MAIN extends Activity {
	
	// Debugging
    private static final String TAG = "CAN_Monitor";
    private static final boolean D = true;
    
    // Message types sent from the BluetoothService Handler
    public static final int MESSAGE_STATE_CHANGE = 1;
    public static final int MESSAGE_READ = 2;
    public static final int MESSAGE_WRITE = 3;
    public static final int MESSAGE_DEVICE_NAME = 4;
    public static final int MESSAGE_TOAST = 5;

    // Key names received from the BluetoothService Handler
    public static final String DEVICE_NAME = "device_name";
    public static final String TOAST = "toast";

    // Intent request codes
    private static final int REQUEST_CONNECT_DEVICE_SECURE = 1;
    private static final int REQUEST_CONNECT_DEVICE_INSECURE = 2;
    private static final int REQUEST_ENABLE_BT = 3;
    
    // Offsets to get ID, ID Add On and Data out of the Buffer
    private static final int OFFSET_ID = 0;
    private static final int OFFSET_IDADDON = 2;
    private static final int OFFSET_DATA=4;
    
    // IDs
    private static final int ID_REVS = 0x105;
    private static final int ID_SPEED = 0x19F;
    private static final int ID_FUEL = 0x39D;
    private static final int ID_ENGINE_TEMP = 0x24D;
    private static final int ID_OUTDOOR_TEMP = 0x139;
    private static final int ID_MILEAGE = 0x37A;
     
 
    // Fragments
    // public Test_Fragment testFrag;
    public Tacho_Fragment tachoFrag;
    public Overview_Fragment overviewFrag;
    public static DataLogger_Fragment dataLogFrag;
    public FragmentTransaction transaction;
    
    // Name of the connected device
    private String mConnectedDeviceName = null;
	// Local Bluetooth adapter
    private BluetoothAdapter mBluetoothAdapter = null;
    // Member object for the bluetooth services
    private BluetoothService mBTService = null;
    
    //Signale
    int speed = 0;
  	int revs = 0;
  	int fuel = 0;
  	double engTemp = 0;
  	long mileage = 0;
  	double ambientTemp = 0;
  	int gear = 0;
  	
    //Simulation
  	int SPEED[] = {0, 0, 0, 0, 0, 0, 0, 1, 1, 3, 5, 8, 10, 12, 14, 16, 18, 20, 22, 24, 26, 28, 30, 33, 35, 37, 39, 41, 44, 46, 48, 50, 52, 54, 56, 57, 58, 59, 61, 62, 64, 66, 67, 69, 71, 72, 74, 75, 77, 78, 80, 81, 83, 84, 86, 87, 88, 89, 90, 91, 92, 93, 95, 96, 97, 98, 99, 101, 102, 103, 104, 106, 107, 108, 109, 110, 112, 113, 114, 115, 116, 117, 118, 119, 120, 121, 122, 123, 124, 125, 126, 127, 128, 129, 130, 131, 132, 133, 134, 134, 135, 136, 137, 138, 139, 139, 140, 141, 142, 143, 144, 145, 145, 146, 147, 148, 149, 150, 150, 151, 152, 153, 153, 154, 155, 156, 156, 157, 158, 159, 159, 160, 161, 162, 162, 163, 164, 164, 165, 166, 166, 167, 168, 168, 168, 169, 170, 170, 171, 172, 172, 173, 174, 174, 175, 175, 176, 177, 177, 178, 179, 179, 180, 180, 181, 182, 182, 183, 183, 184, 185, 185, 186, 186, 187, 187, 188, 189, 189, 190, 190, 190, 191, 192, 192, 193, 193, 194, 194, 195, 195, 195, 196, 196, 197, 197, 198, 198, 199, 199, 200, 200, 201, 201, 202, 202, 203, 203, 204, 204, 205, 205, 206, 206, 206, 207, 207, 208, 208, 208, 209, 209, 210, 210, 211, 211, 211, 212, 212, 213, 213, 214, 214, 214, 215, 215, 216, 216, 216, 217, 217, 218, 218, 218, 219, 219, 219, 220, 220, 220, 221, 221, 221, 222, 222, 223, 223, 223, 224, 224, 224, 225, 225, 226, 226, 226, 227, 227, 227, 228, 228, 229, 229, 229, 230, 230, 230, 231, 231, 231, 232, 232, 232, 233, 233, 233, 234, 234, 234, 235, 235, 235, 236, 236, 236, 236, 237, 237, 237, 238, 238, 238, 238, 239, 239, 239, 240, 240, 240, 240, 241, 241, 241, 241, 242, 242, 242, 242, 243, 243, 243, 243, 244, 244, 244, 245, 245, 245, 245, 246, 246, 246, 246, 247, 247, 247, 247, 248, 248, 248, 248, 248, 249, 249, 249, 249, 250, 250, 250, 250, 251, 251, 251, 251, 251, 252, 252, 252, 252, 252, 252, 253, 253, 253, 253, 253, 253, 253, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 254, 254, 253, 253, 253, 252, 253, 252, 252, 252, 252, 252, 252, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 252, 251, 249, 247, 246, 244, 243, 241, 240, 238, 237, 235, 234, 232, 231, 229, 227, 226, 224, 223, 222, 220, 218, 217, 215, 214, 212, 211, 209, 208, 206, 205, 203, 202, 200, 199, 197, 196, 195, 193, 192, 191, 189, 188, 187, 185, 184, 183, 181, 180, 179, 177, 176, 175, 173, 172, 171, 170, 169, 168, 167, 166, 164, 163, 162, 161, 160, 159, 158, 157, 156, 155, 154, 153, 152, 151, 150, 149, 148, 147, 146, 145, 145, 144, 143, 142, 141, 140, 139, 138, 138, 137, 136, 135, 134, 133, 132, 131, 130, 130, 129, 128, 127, 126, 125, 124, 123, 122, 121, 120, 119, 118, 118, 117, 116, 115, 114, 113, 112, 111, 110, 109, 108, 108, 108, 108, 107, 107, 107, 107, 106, 106, 106, 106, 105, 105, 105, 105, 105, 104, 104, 104, 104, 103, 103, 103, 103, 102, 102, 102, 101, 101, 101, 101, 100, 100, 100, 99, 99, 99, 99, 98, 98, 98, 98, 97, 97, 97, 96, 96, 96, 96, 95, 95, 95, 95, 95, 94, 94, 94, 94, 94, 94, 93, 93, 93, 93, 93, 92, 92, 92, 92, 91, 92, 91, 91, 91, 91, 91, 91, 91, 91, 91, 91, 91, 91, 91, 91, 91, 91, 92, 92, 92, 92, 92, 92, 92, 92, 92, 92, 92, 92, 92, 92, 92, 92, 92, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 94, 94, 94, 94, 94, 94, 94, 94, 94, 95, 95, 95, 95, 95, 95, 95, 95, 95, 95, 95, 95, 95, 95, 94, 94, 94, 94, 94, 94, 94, 94, 94, 94, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 94, 94, 94, 94, 94, 94, 95, 95, 95, 95, 96, 96, 96, 96, 96, 96, 96, 96, 95, 95, 94, 93, 92, 91, 90, 89, 88, 87, 86, 84, 83, 82, 81, 80, 79, 77, 76, 74, 73, 71, 70, 68, 67, 65, 63, 62, 60, 58, 57, 55, 53, 52, 50, 48, 47, 45, 43, 41, 39, 37, 35, 34, 32, 30, 28, 27, 25, 23, 21, 20, 18, 17, 15, 14, 12, 11, 10, 8, 7, 6, 5, 4, 3, 2, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 2, 4, 7, 9, 11, 13, 15, 17, 19, 21, 23, 25, 28, 30, 32, 35, 37, 39, 41, 44, 46, 48, 50, 52, 53, 54, 56, 57, 59, 61, 63, 64, 66, 68, 69, 71, 73, 74, 76, 77, 79, 80, 82, 83, 84, 84, 85, 87, 88, 89, 91, 92, 93, 94, 95, 97, 98, 99, 100, 102, 103, 104, 105, 106, 108, 109, 110, 111, 112, 113, 114, 115, 116, 117, 118, 119, 120, 121, 122, 123, 123, 124, 125, 126, 127, 128, 129, 130, 131, 131, 132, 133, 134, 135, 136, 136, 137, 138, 139, 140, 141, 141, 142, 143, 144, 145, 145, 146, 147, 148, 148, 149, 150, 151, 152, 152, 153, 154, 154, 155, 156, 156, 157, 158, 158, 159, 160, 160, 161, 162, 162, 163, 164, 164, 165, 166, 166, 167, 167, 168, 168, 169, 169, 170, 170, 171, 171, 172, 172, 173, 173, 174, 174, 175, 175, 176, 176, 177, 177, 178, 178, 179, 179, 180, 180, 181, 181, 182, 182, 183, 183, 184, 184, 185, 185, 186, 186, 187, 187, 188, 188, 189, 189, 190, 190, 191, 191, 192, 192, 193, 193, 194, 194, 195, 195, 196, 196, 197, 197, 197, 198, 198, 199, 199, 199, 200, 200, 200, 201, 201, 201, 202, 202, 202, 203, 203, 203, 204, 204, 204, 205, 205, 206, 206, 206, 207, 207, 207, 208, 208, 208, 209, 209, 209, 210, 210, 211, 211, 211, 212, 212, 212, 213, 213, 213, 214, 214, 215, 215, 216, 216, 216, 216, 217, 217, 217, 218, 218, 218, 219, 219, 219, 220, 220, 220, 221, 221, 221, 222, 222, 222, 222, 223, 223, 223, 224, 224, 224, 225, 225, 225, 226, 226, 226, 227, 227, 227, 228, 228, 228, 228, 229, 229, 229, 229, 229, 230, 230, 230, 230, 230, 230, 231, 231, 231, 231, 231, 231, 232, 232, 232, 232, 232, 232, 232, 233, 233, 233, 233, 233, 234, 234, 233, 234, 234, 234, 235, 235, 235, 235, 235, 235, 235, 235, 235, 236, 236, 236, 236, 237, 237, 237, 237, 237, 237, 237, 238, 238, 238, 238, 238, 238, 238, 238, 238, 239, 239, 239, 239, 239, 239, 240, 240, 240, 240, 240, 240, 240, 241, 241, 241, 241, 241, 241, 241, 241, 242, 242, 242, 242, 242, 242, 243, 243, 243, 243, 243, 243, 243, 244, 243, 244, 244, 244, 244, 244, 244, 244, 244, 245, 245, 245, 245, 245, 245, 245, 246, 245, 246, 246, 246, 246, 246, 246, 246, 246, 246, 246, 246, 246, 246, 246, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 248, 248, 248, 248, 248, 248, 249, 249, 249, 249, 249, 249, 249, 249, 249, 249, 249, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 251, 251, 251, 251, 251, 251, 251, 251, 252, 252, 252, 252, 252, 251, 252, 252, 252, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 252, 252, 251, 251, 250, 249, 248, 247, 246, 245, 244, 243, 242, 240, 239, 237, 236, 235, 233, 232, 231, 229, 228, 227, 225, 224, 222, 221, 220, 218, 217, 215, 214, 212, 211, 208, 207, 205, 203, 202, 200, 198, 197, 195, 193, 191, 190, 188, 187, 185, 184, 182, 180, 178, 177, 176, 174, 173, 171, 169, 167, 166, 165, 164, 162, 161, 159, 158, 157, 156, 155, 154, 152, 151, 150, 150, 149, 149, 149, 148, 148, 147, 147, 147, 147, 146, 146, 146, 145, 145, 145, 145, 144, 144, 144, 143, 143, 143, 142, 142, 142, 142, 141, 141, 141, 140, 140, 140, 139, 139, 139, 138, 138, 138, 138, 137, 137, 137, 136, 136, 136, 136, 135, 135, 135, 135, 134, 134, 134, 134, 133, 133, 133, 132, 132, 132, 132, 131, 131, 131, 131, 130, 130, 130, 130, 129, 129, 129, 129, 128, 128, 127, 127, 126, 126, 125, 124, 124, 123, 122, 121, 121, 120, 119, 118, 117, 116, 116, 115, 114, 113, 113, 112, 111, 110, 110, 110, 109, 109, 109, 109, 109, 108, 108, 108, 108, 107, 107, 107, 107, 106, 106, 106, 106, 105, 105, 104, 104, 104, 104, 104, 104, 104, 104, 104, 104, 105, 105, 105, 105, 105, 105, 105, 106, 106, 106, 106, 106, 107, 107, 107, 107, 107, 108, 108, 108, 108, 109, 109, 109, 109, 109, 109, 109, 109, 109, 109, 109, 109, 109, 109, 109, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 110, 110, 110, 110, 110, 110, 110, 109, 109, 109, 109, 109, 109, 109, 109, 108, 108, 108, 108, 107, 107, 107, 107, 106, 106, 106, 106, 105, 105, 105, 105, 104, 104, 104, 104, 103, 103, 103, 102, 102, 102, 102, 102, 101, 101, 101, 101, 100, 100, 100, 100, 99, 99, 99, 99, 98, 98, 98, 98, 98, 97, 97, 97, 97, 96, 96, 96, 96, 95, 95, 95, 95, 95, 94, 94, 94, 94, 94, 93, 93, 93, 93, 93, 92, 92, 92, 92, 92, 91, 91, 91, 91, 91, 90, 90, 90, 90, 90, 89, 89, 89, 89, 89, 89, 88, 88, 88, 88, 88, 87, 87, 87, 87, 87, 87, 86, 86, 86, 86, 86, 86, 86, 86, 85, 85, 85, 85, 85, 85, 85, 85, 84, 84, 84, 84, 84, 84, 84, 83, 83, 83, 83, 83, 82, 82, 82, 81, 81, 80, 80, 79, 79, 78, 78, 77, 76, 76, 75, 74, 73, 72, 71, 71, 70, 69, 68, 67, 66, 65, 64, 64, 63, 62, 61, 61, 60, 59, 59, 57, 56, 55, 53, 52, 50, 49, 47, 45, 43, 42, 40, 38, 36, 35, 33, 32, 30, 29, 28, 27, 26, 25, 24, 24, 23, 23, 23, 23, 23, 23, 23, 22, 22, 22, 21, 21, 21, 22, 22, 23, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 38, 39, 40, 42, 43, 45, 46, 47, 49, 50, 52, 53, 55, 56, 58, 59, 61, 62, 64, 65, 67, 68, 69, 71, 72, 74, 75, 76, 76, 77, 76, 77, 77, 77, 77, 77, 77, 76, 76, 76, 75, 75, 74, 73, 73, 72, 71, 70, 70, 69, 68, 67, 66
  		     	  };
  	int ENGSPEED[] = {552, 552, 560, 574, 614, 757, 960, 1276, 1694, 1971, 2075, 2100, 2116, 2180, 2281, 2391, 2521, 2658, 2823, 3049, 3310, 3512, 3697, 3904, 4190, 4394, 4642, 4893, 5119, 5364, 5574, 5785, 6002, 6181, 6285, 6427, 6541, 5998, 5317, 4857, 4874, 4906, 5044, 5158, 5274, 5392, 5496, 5618, 5731, 5838, 5947, 6060, 6151, 6268, 6359, 6451, 6468, 6437, 5915, 5202, 4720, 4703, 4694, 4773, 4817, 4881, 4940, 4988, 5059, 5110, 5176, 5230, 5291, 5346, 5416, 5463, 5520, 5575, 5630, 5686, 5739, 5799, 5841, 5899, 5948, 5996, 6047, 6091, 6133, 6188, 6234, 6280, 6331, 6378, 6421, 6470, 6512, 6516, 5977, 5504, 5332, 5312, 5340, 5374, 5412, 5438, 5469, 5506, 5543, 5575, 5609, 5642, 5672, 5702, 5729, 5756, 5798, 5822, 5851, 5884, 5916, 5938, 5980, 6005, 6036, 6069, 6089, 6116, 6146, 6171, 6196, 6229, 6255, 6281, 6317, 6336, 6362, 6388, 6420, 6440, 6474, 6492, 6482, 5813, 5271, 5120, 5089, 5116, 5129, 5151, 5169, 5188, 5206, 5216, 5240, 5250, 5278, 5290, 5320, 5324, 5351, 5364, 5382, 5403, 5416, 5430, 5458, 5472, 5482, 5500, 5518, 5536, 5558, 5575, 5593, 5603, 5623, 5647, 5659, 5670, 5684, 5707, 5723, 5749, 5757, 5774, 5784, 5806, 5821, 5831, 5839, 5868, 5880, 5888, 5900, 5913, 5939, 5947, 5956, 5975, 5985, 5994, 6015, 6022, 6036, 6057, 6065, 6080, 6089, 6104, 6124, 6136, 6151, 6161, 6179, 6183, 6196, 6205, 6227, 6235, 6248, 6264, 6275, 6284, 6290, 6302, 6317, 6328, 6342, 6348, 6367, 6373, 6385, 6391, 6406, 6422, 6432, 6448, 6450, 6468, 6470, 6483, 6496, 6509, 6550, 6141, 5642, 5219, 5115, 5117, 5123, 5130, 5138, 5153, 5152, 5158, 5170, 5182, 5182, 5197, 5206, 5209, 5221, 5225, 5231, 5247, 5252, 5261, 5271, 5281, 5285, 5287, 5298, 5307, 5322, 5324, 5332, 5340, 5346, 5355, 5357, 5363, 5373, 5377, 5393, 5394, 5401, 5408, 5416, 5423, 5436, 5435, 5438, 5449, 5460, 5461, 5462, 5467, 5485, 5492, 5497, 5500, 5502, 5511, 5521, 5530, 5537, 5537, 5549, 5549, 5549, 5560, 5566, 5571, 5580, 5581, 5588, 5595, 5596, 5606, 5613, 5615, 5624, 5625, 5633, 5639, 5648, 5652, 5656, 5665, 5674, 5675, 5681, 5682, 5686, 5695, 5704, 5713, 5704, 5713, 5712, 5726, 5736, 5735, 5745, 5746, 5752, 5754, 5762, 5768, 5776, 5775, 5779, 5787, 5779, 5785, 5795, 5794, 5802, 5807, 5804, 5810, 5821, 5820, 5825, 5829, 5829, 5839, 5831, 5836, 5847, 5843, 5843, 5840, 5851, 5857, 5855, 5862, 5855, 5857, 5859, 5864, 5868, 5865, 5872, 5868, 5877, 5870, 5871, 5871, 5873, 5881, 5874, 5880, 5878, 5884, 5882, 5880, 5880, 5880, 5881, 5882, 5880, 5887, 5883, 5888, 5888, 5889, 5882, 5885, 5885, 5886, 5888, 5880, 5883, 5880, 5885, 5880, 5879, 5877, 5878, 5875, 5871, 5871, 5873, 5874, 5873, 5879, 5871, 5872, 5870, 5877, 5868, 5871, 5863, 5863, 5868, 5862, 5825, 5814, 5812, 5792, 5802, 5821, 5828, 5838, 5801, 5804, 5802, 5815, 5814, 5809, 5808, 5807, 5813, 5822, 5816, 5816, 5818, 5814, 5822, 5822, 5773, 5799, 5765, 5753, 5707, 5679, 5635, 5601, 5571, 5516, 5506, 5459, 5429, 5406, 5358, 5329, 5287, 5270, 5225, 5177, 5151, 5120, 5098, 5056, 5018, 4984, 4950, 4919, 4889, 4853, 4817, 4793, 4748, 4715, 4691, 4653, 4624, 4598, 4556, 4536, 4501, 4464, 4440, 4411, 4375, 4341, 4312, 4277, 4247, 4222, 4191, 4161, 4133, 4107, 4078, 4044, 4011, 3985, 3965, 3935, 3915, 3893, 3870, 3844, 3815, 3786, 3758, 3736, 3715, 3690, 3666, 3640, 3617, 3589, 3568, 3544, 3519, 3499, 3478, 3458, 3439, 3419, 3398, 3382, 3362, 3342, 3320, 3299, 3284, 3260, 3242, 3215, 3199, 3182, 3162, 3139, 3121, 3100, 3083, 3062, 3041, 3020, 2996, 2977, 2954, 2935, 2915, 2893, 2872, 2848, 2828, 2805, 2779, 2759, 2740, 2720, 2700, 2678, 2657, 2635, 2612, 2593, 2571, 2545, 2528, 2512, 2506, 2502, 2496, 2489, 2487, 2481, 2480, 2472, 2461, 2458, 2454, 2446, 2440, 2434, 2428, 2425, 2418, 2410, 2404, 2401, 2394, 2390, 2385, 2375, 2370, 2363, 2357, 2349, 2346, 2339, 2332, 2324, 2321, 2315, 2303, 2294, 2292, 2286, 2277, 2271, 2259, 2256, 2250, 2245, 2237, 2240, 2232, 2233, 2228, 2224, 2219, 2214, 2219, 2211, 2199, 2197, 2189, 2177, 2175, 2181, 2175, 2171, 2170, 2168, 2163, 2155, 2152, 2153, 2150, 2147, 2146, 2145, 2145, 2145, 2153, 2150, 2148, 2149, 2142, 2141, 2144, 2143, 2145, 2148, 2148, 2149, 2160, 2156, 2161, 2165, 2156, 2160, 2161, 2161, 2158, 2161, 2168, 2165, 2167, 2169, 2169, 2168, 2170, 2166, 2170, 2172, 2175, 2174, 2174, 2179, 2179, 2177, 2181, 2183, 2186, 2183, 2181, 2191, 2204, 2194, 2195, 2195, 2196, 2203, 2207, 2210, 2227, 2217, 2214, 2218, 2220, 2217, 2216, 2220, 2223, 2223, 2223, 2221, 2219, 2220, 2220, 2219, 2218, 2220, 2216, 2214, 2214, 2211, 2208, 2206, 2201, 2197, 2194, 2196, 2191, 2195, 2197, 2198, 2196, 2197, 2193, 2195, 2192, 2192, 2195, 2194, 2194, 2193, 2191, 2194, 2194, 2196, 2197, 2201, 2194, 2195, 2216, 2224, 2209, 2224, 2232, 2242, 2249, 2267, 2235, 2221, 2230, 2249, 2237, 2231, 2228, 2195, 2192, 2166, 2155, 2136, 2110, 2090, 2066, 2048, 2019, 1987, 1958, 1937, 1911, 1881, 1850, 1814, 1777, 1745, 1710, 1678, 1641, 1604, 1571, 1528, 1491, 1459, 1419, 1381, 1339, 1303, 1260, 1232, 1211, 1209, 1269, 1341, 1508, 1634, 1614, 1468, 1441, 1360, 1288, 1216, 1146, 1152, 1226, 1290, 1358, 1379, 1346, 1304, 1206, 1111, 1052, 943, 813, 738, 759, 764, 730, 706, 718, 737, 746, 738, 741, 735, 727, 715, 702, 689, 669, 655, 650, 675, 749, 867, 1109, 1462, 1858, 2041, 2097, 2104, 2153, 2243, 2355, 2487, 2637, 2797, 3029, 3293, 3543, 3699, 3911, 4195, 4429, 4652, 4891, 5156, 5363, 5562, 5750, 5898, 6037, 6144, 5990, 5647, 5268, 4988, 4807, 4902, 4946, 5097, 5199, 5330, 5442, 5553, 5662, 5765, 5898, 5962, 6021, 6118, 5998, 5675, 5273, 4927, 4558, 4509, 4499, 4588, 4645, 4700, 4756, 4822, 4883, 4932, 5001, 5053, 5109, 5177, 5234, 5285, 5351, 5408, 5458, 5509, 5571, 5619, 5670, 5727, 5783, 5831, 5884, 5924, 5962, 5986, 6039, 5883, 5587, 5268, 4988, 4966, 4994, 5022, 5067, 5093, 5129, 5156, 5190, 5222, 5254, 5290, 5315, 5357, 5384, 5412, 5452, 5482, 5514, 5537, 5569, 5596, 5631, 5651, 5692, 5715, 5746, 5768, 5800, 5836, 5849, 5889, 5910, 5957, 5979, 6000, 6026, 6024, 5782, 5453, 5145, 4851, 4773, 4798, 4813, 4831, 4853, 4862, 4878, 4899, 4920, 4938, 4957, 4982, 5005, 5019, 5031, 5027, 4791, 4547, 4215, 4007, 3987, 3998, 4007, 4021, 4025, 4036, 4048, 4056, 4066, 4077, 4090, 4097, 4109, 4119, 4126, 4141, 4154, 4165, 4181, 4189, 4199, 4212, 4217, 4233, 4239, 4260, 4261, 4283, 4294, 4301, 4317, 4324, 4333, 4349, 4361, 4373, 4388, 4404, 4422, 4429, 4442, 4459, 4464, 4471, 4491, 4504, 4518, 4533, 4537, 4551, 4556, 4567, 4582, 4601, 4611, 4623, 4623, 4619, 4453, 4198, 3952, 3918, 3930, 3929, 3934, 3945, 3941, 3958, 3956, 3966, 3970, 3977, 3981, 3987, 3992, 3999, 4000, 4012, 4022, 4022, 4037, 4044, 4037, 4046, 4070, 4065, 4073, 4080, 4089, 4086, 4092, 4101, 4110, 4116, 4126, 4125, 4137, 4143, 4156, 4159, 4163, 4171, 4175, 4182, 4208, 4201, 4200, 4208, 4222, 4229, 4234, 4234, 4245, 4246, 4259, 4271, 4268, 4276, 4280, 4291, 4286, 4282, 4306, 4319, 4319, 4312, 4321, 4339, 4338, 4342, 4359, 4363, 4361, 4364, 4371, 4376, 4388, 4390, 4399, 4399, 4411, 4425, 4431, 4443, 4465, 4447, 4361, 4087, 3713, 3553, 3529, 3548, 3548, 3550, 3552, 3557, 3555, 3550, 3554, 3559, 3556, 3566, 3568, 3570, 3574, 3573, 3577, 3587, 3579, 3587, 3584, 3592, 3585, 3592, 3596, 3602, 3606, 3596, 3605, 3613, 3612, 3612, 3614, 3618, 3621, 3628, 3630, 3630, 3630, 3629, 3632, 3641, 3642, 3642, 3641, 3647, 3648, 3643, 3652, 3657, 3652, 3655, 3655, 3664, 3665, 3668, 3668, 3673, 3673, 3670, 3681, 3678, 3683, 3679, 3681, 3689, 3693, 3686, 3689, 3696, 3697, 3699, 3701, 3705, 3707, 3706, 3709, 3709, 3711, 3710, 3710, 3719, 3717, 3719, 3723, 3729, 3725, 3723, 3733, 3725, 3737, 3735, 3731, 3737, 3745, 3742, 3734, 3738, 3747, 3749, 3753, 3752, 3755, 3758, 3755, 3762, 3769, 3761, 3761, 3763, 3772, 3773, 3769, 3773, 3774, 3774, 3782, 3775, 3774, 3780, 3787, 3784, 3786, 3787, 3784, 3795, 3792, 3795, 3797, 3799, 3801, 3797, 3816, 3792, 3804, 3799, 3806, 3812, 3814, 3818, 3822, 3825, 3819, 3816, 3819, 3822, 3817, 3817, 3831, 3820, 3820, 3817, 3826, 3836, 3844, 3843, 3836, 3834, 3834, 3842, 3843, 3841, 3850, 3825, 3833, 3850, 3843, 3851, 3851, 3856, 3859, 3855, 3862, 3858, 3860, 3864, 3868, 3860, 3864, 3884, 3877, 3865, 3875, 3871, 3875, 3880, 3872, 3881, 3877, 3880, 3883, 3829, 3845, 3843, 3841, 3835, 3816, 3811, 3773, 3780, 3775, 3749, 3739, 3725, 3716, 3682, 3665, 3640, 3625, 3607, 3579, 3557, 3529, 3518, 3490, 3476, 3452, 3439, 3424, 3394, 3380, 3350, 3320, 3292, 3276, 3260, 3231, 3217, 3172, 3159, 3135, 3104, 3081, 3057, 3035, 3013, 2989, 2956, 2926, 2903, 2880, 2861, 2840, 2813, 2787, 2759, 2724, 2711, 2691, 2668, 2638, 2620, 2590, 2559, 2539, 2518, 2505, 2482, 2456, 2434, 2417, 2402, 2385, 2370, 2353, 2340, 2324, 2311, 2299, 2290, 2286, 2285, 2281, 2277, 2274, 2266, 2263, 2259, 2254, 2248, 2244, 2238, 2235, 2228, 2225, 2221, 2217, 2212, 2207, 2202, 2198, 2193, 2190, 2185, 2181, 2173, 2170, 2166, 2160, 2160, 2151, 2148, 2143, 2140, 2136, 2129, 2128, 2121, 2119, 2113, 2111, 2107, 2101, 2097, 2094, 2088, 2085, 2081, 2079, 2072, 2070, 2065, 2062, 2056, 2053, 2049, 2042, 2039, 2036, 2034, 2031, 2023, 2022, 2018, 2012, 2013, 2008, 2004, 2000, 1996, 1990, 1988, 1980, 1972, 1965, 1958, 1950, 1936, 1930, 1917, 1907, 1897, 1883, 1868, 1857, 1847, 1835, 1820, 1805, 1794, 1780, 1768, 1755, 1744, 1730, 1715, 1707, 1693, 1687, 1685, 1682, 1680, 1680, 1677, 1673, 1667, 1664, 1662, 1655, 1652, 1647, 1644, 1645, 1654, 1650, 1636, 1642, 1636, 1634, 1631, 1638, 1636, 1633, 1633, 1665, 1650, 1640, 1637, 1654, 1650, 1645, 1625, 1663, 1659, 1643, 1641, 1673, 1664, 1659, 1644, 1688, 1677, 1703, 1787, 1856, 2015, 2171, 2218, 2142, 2132, 2142, 2130, 2140, 2137, 2140, 2134, 2138, 2141, 2139, 2147, 2139, 2148, 2151, 2146, 2157, 2150, 2167, 2161, 2156, 2168, 2157, 2167, 2167, 2164, 2173, 2167, 2170, 2172, 2167, 2174, 2169, 2166, 2172, 2171, 2174, 2171, 2168, 2170, 2163, 2164, 2154, 2155, 2155, 2151, 2149, 2143, 2137, 2123, 2129, 2127, 2121, 2119, 2110, 2096, 2092, 2094, 2084, 2076, 2074, 2068, 2065, 2060, 2057, 2052, 2046, 2042, 2036, 2029, 2025, 2019, 2014, 2011, 2006, 2001, 1996, 1993, 1985, 1981, 1975, 1973, 1967, 1964, 1961, 1955, 1950, 1943, 1943, 1936, 1930, 1927, 1922, 1918, 1914, 1910, 1907, 1899, 1894, 1891, 1888, 1883, 1875, 1871, 1867, 1861, 1858, 1855, 1850, 1850, 1847, 1839, 1833, 1831, 1829, 1823, 1817, 1814, 1807, 1804, 1801, 1797, 1793, 1790, 1786, 1786, 1780, 1777, 1774, 1770, 1766, 1761, 1756, 1755, 1752, 1748, 1745, 1740, 1736, 1732, 1730, 1727, 1723, 1720, 1716, 1714, 1707, 1707, 1703, 1701, 1698, 1694, 1689, 1689, 1690, 1688, 1687, 1680, 1676, 1671, 1667, 1667, 1661, 1660, 1659, 1658, 1655, 1653, 1651, 1649, 1642, 1641, 1640, 1640, 1634, 1632, 1631, 1625, 1625, 1621, 1615, 1607, 1605, 1598, 1589, 1582, 1571, 1563, 1551, 1542, 1532, 1522, 1513, 1499, 1489, 1471, 1455, 1434, 1420, 1403, 1391, 1465, 1546, 1566, 1566, 1546, 1514, 1488, 1467, 1457, 1451, 1440, 1427, 1408, 1393, 1379, 1359, 1332, 1304, 1268, 1232, 1193, 1154, 1111, 1071, 1077, 1091, 1109, 1087, 1071, 1125, 1165, 1160, 1141, 1100, 1069, 1036, 992, 955, 922, 910, 870, 865, 841, 960, 1076, 1179, 1260, 1336, 1414, 1501, 1587, 1635, 1626, 1620, 1664, 1697, 1724, 1800, 1887, 1949, 2042, 2130, 2173, 2272, 2332, 2408, 2491, 2505, 2347, 2241, 2140, 2053, 2110, 2104, 2135, 2217, 2280, 2337, 2403, 2467, 2554, 2599, 2677, 2758, 2826, 2901, 2970, 3029, 3117, 3200, 3270, 3347, 3419, 3488, 3560, 3631, 3702, 3679, 3745, 3745, 3750, 3741, 3648, 3535, 3370, 3199, 3061, 2945, 2957, 2943, 2921, 2910, 2884, 2860, 2844, 2816, 2792, 2761, 2732, 2700, 2671, 2638, 2606, 2572
  	                 };
  	int GEAR[] = {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4
  	             };
  	int l = SPEED.length;
  	private static Thread thread;
  	
  	//DataLogger-Fragment Variablen
    double time = 0;
	long temp_time0 = 0;
	long temp_time1 = 0;
	boolean revsflag = false;
    boolean speedflag = false;
	boolean dataflag = false;
	boolean firstround = true;
  	
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        if(D) Log.e(TAG, "+++ ON CREATE +++");
        
        setContentView(R.layout.main);
        
        actionBarConfig();
        
     // Get local Bluetooth adapter
        mBluetoothAdapter = BluetoothAdapter.getDefaultAdapter();
        
        // If the adapter is null, then Bluetooth is not supported
        if (mBluetoothAdapter == null) {
            Toast.makeText(this, "Bluetooth is not available", Toast.LENGTH_LONG).show();
            finish();
            return;
        }
    }

	@Override
    public void onStart() {
    	super.onStart();
    	if(D) Log.e(TAG, "++ ON START ++");
    	
    	// If BT is not on, request that it be enabled.
        // setup() will then be called during onActivityResult
        if (!mBluetoothAdapter.isEnabled()) {
            Intent enableIntent = new Intent(BluetoothAdapter.ACTION_REQUEST_ENABLE);
            startActivityForResult(enableIntent, REQUEST_ENABLE_BT);
        // Otherwise, setup the session
        } else {
        	if (mBTService == null) setupBT();
        }
    }
    
    @Override
    public void onResume() {
    	// TODO Auto-generated method stub
    	super.onResume();
    	if(D) Log.e(TAG, "+ ON RESUME +");

        // Performing this check in onResume() covers the case in which BT was
        // not enabled during onStart(), so we were paused to enable it...
        // onResume() will be called when ACTION_REQUEST_ENABLE activity returns.
        if (mBTService != null) {
            // Only if the state is STATE_NONE, do we know that we haven't started already
            if (mBTService.getState() == BluetoothService.STATE_NONE) {
              // Start the Bluetooth chat services
              mBTService.start();
            }
        }
    }

    private void setupBT(){
    	// Initialize the BluetoothChatService to perform bluetooth connections
        mBTService = new BluetoothService(this, mHandler);
    }
    
    @Override
    public synchronized void onPause() {
        super.onPause();
        if(D) Log.e(TAG, "- ON PAUSE -");
    }

    @Override
    public void onStop() {
        super.onStop();
        if(D) Log.e(TAG, "-- ON STOP --");
    }
    
    @Override
    public void onDestroy() {
        super.onDestroy();
        // Stop the Bluetooth chat services
        if (mBTService != null) mBTService.stop();
        if(D) Log.e(TAG, "--- ON DESTROY ---");
    }

    private void ensureDiscoverable() {
        if(D) Log.d(TAG, "ensure discoverable");
        if (mBluetoothAdapter.getScanMode() !=
            BluetoothAdapter.SCAN_MODE_CONNECTABLE_DISCOVERABLE) {
            Intent discoverableIntent = new Intent(BluetoothAdapter.ACTION_REQUEST_DISCOVERABLE);
            discoverableIntent.putExtra(BluetoothAdapter.EXTRA_DISCOVERABLE_DURATION, 300);
            startActivity(discoverableIntent);
        }
    }
    
    private final void setStatus(int resId) {
        final ActionBar actionBar = getActionBar();
        actionBar.setSubtitle(resId);
    }
    
    private final void setStatus(CharSequence subTitle) {
        final ActionBar actionBar = getActionBar();
        actionBar.setSubtitle(subTitle);
    }
    
 // The Handler that gets information back from the BluetoothChatService
    private final Handler mHandler = new Handler() {
        @Override
        public void handleMessage(Message msg) {
            switch (msg.what) {
            case MESSAGE_STATE_CHANGE:
                if(D) Log.i(TAG, "MESSAGE_STATE_CHANGE: " + msg.arg1);
                switch (msg.arg1) {
                case BluetoothService.STATE_CONNECTED:
                    setStatus(getString(R.string.title_connected_to, mConnectedDeviceName));
                    break;
                case BluetoothService.STATE_CONNECTING:
                    setStatus(R.string.title_connecting);
                    break;
                case BluetoothService.STATE_LISTEN:
                case BluetoothService.STATE_NONE:
                    setStatus(R.string.title_not_connected);
                    break;
                }
                break;
            case MESSAGE_READ:
            	// String 
                byte[] readBuf = (byte[]) msg.obj;
                int readBytes = msg.arg1;
                
                if (readBytes == 8) {
                    processData(readBuf);
				}
                break;
            case MESSAGE_DEVICE_NAME:
                // save the connected device's name
                mConnectedDeviceName = msg.getData().getString(DEVICE_NAME);
                Toast.makeText(getApplicationContext(), "Connected to "
                               + mConnectedDeviceName, Toast.LENGTH_SHORT).show();
                break;
            case MESSAGE_TOAST:
                Toast.makeText(getApplicationContext(), msg.getData().getString(TOAST),
                               Toast.LENGTH_SHORT).show();
                break;
            }
        }
    };
    
    public void onActivityResult(int requestCode, int resultCode, Intent data) {
        if(D) Log.d(TAG, "onActivityResult " + resultCode);
        switch (requestCode) {
        case REQUEST_CONNECT_DEVICE_SECURE:
            // When DeviceListActivity returns with a device to connect
            if (resultCode == Activity.RESULT_OK) {
                connectDevice(data, true);
            }
            break;
        case REQUEST_CONNECT_DEVICE_INSECURE:
            // When DeviceListActivity returns with a device to connect
            if (resultCode == Activity.RESULT_OK) {
                connectDevice(data, false);
            }
            break;
        case REQUEST_ENABLE_BT:
            // When the request to enable Bluetooth returns
            if (resultCode == Activity.RESULT_OK) {
                // Bluetooth is now enabled, so set up a bluetooth session
                setupBT();
            } else {
                // User did not enable Bluetooth or an error occurred
                Log.d(TAG, "BT not enabled");
                Toast.makeText(this, R.string.bt_not_enabled_leaving, Toast.LENGTH_SHORT).show();
                finish();
            }
        }
    }
    
    private void connectDevice(Intent data, boolean secure) {
        // Get the device MAC address
        String address = data.getExtras()
            .getString(DeviceListActivity.EXTRA_DEVICE_ADDRESS);
        // Get the BluetoothDevice object
        BluetoothDevice device = mBluetoothAdapter.getRemoteDevice(address);
        // Attempt to connect to the device
        mBTService.connect(device, secure);
    }
    
    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        MenuInflater inflater = getMenuInflater();
        inflater.inflate(R.menu.option_menu, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        Intent serverIntent = null;
        switch (item.getItemId()) {
        case R.id.secure_connect_scan:
            // Launch the DeviceListActivity to see devices and do scan
            serverIntent = new Intent(this, DeviceListActivity.class);
            startActivityForResult(serverIntent, REQUEST_CONNECT_DEVICE_SECURE);
            return true;
//        case R.id.insecure_connect_scan:
//            // Launch the DeviceListActivity to see devices and do scan
//            serverIntent = new Intent(this, DeviceListActivity.class);
//            startActivityForResult(serverIntent, REQUEST_CONNECT_DEVICE_INSECURE);
//            return true;
        case R.id.discoverable:
            // Ensure this device is discoverable by others
            ensureDiscoverable();
        
            return true;
            
        case R.id.simulation:
        	Simulation();
        	
        	return true;
        
            
        }
        return false;
    }
    
    private void actionBarConfig() {
		// TODO Auto-generated method stub
    	 final ActionBar bar = getActionBar();
         bar.setNavigationMode(ActionBar.NAVIGATION_MODE_TABS);
         
//         ActionBar.Tab TestTab 		= bar.newTab().setText("BT Test");
         ActionBar.Tab TachoTab 	= bar.newTab().setText("Tacho");
         ActionBar.Tab OverviewTab 	= bar.newTab().setText("berblick");
         ActionBar.Tab DataLoggerTab= bar.newTab().setText("Data Logger");
         
//         Fragment TestFragment 		= new Test_Fragment();
         Fragment TachoFragment 	= new Tacho_Fragment();
         Fragment OverviewFragment 	= new Overview_Fragment();
         Fragment DataLoggerFragment= new DataLogger_Fragment();
         
//         TestTab.setTabListener(new MyTabsListener(TestFragment, "Test"));
         TachoTab.setTabListener(new MyTabsListener(TachoFragment, "Tacho"));
         OverviewTab.setTabListener(new MyTabsListener(OverviewFragment, "Overview"));
         DataLoggerTab.setTabListener(new MyTabsListener(DataLoggerFragment, "DataLogger"));
         
//         bar.addTab(TestTab);
         bar.addTab(TachoTab);
         bar.addTab(OverviewTab);
         bar.addTab(DataLoggerTab);  
	}
    
    public int byteArrayToInt(byte[] b, int offset) {
		int value = 0;
		for (int i = 0 + offset; i < 2 + offset; i++) {
			value = (value << 8) | (b[i] & 0xFF);
		}
    	return value;
	} 
    
    public long byteArrayToLong(byte[] b, int offset) {
		long value = 0;
		for (int i = 0 + offset; i < 4 + offset; i++) {
			value = (value << 8) | (b[i] & 0xFF);
		}
    	return value;
	} 

    // The Method where the Bluetooth-Messages are analyzed and handled to the Fragments
    private void processData(byte[] readBuf){
		int id = byteArrayToInt(readBuf, OFFSET_ID);
//		int idAddOn = byteArrayToInt(readBuf, OFFSET_IDADDON);
		long data = byteArrayToLong(readBuf, OFFSET_DATA);
    	
//    	testFrag = (Test_Fragment) getFragmentManager().findFragmentByTag("Test");
            	
//    	if (testFrag != null && testFrag.isVisible()) {
//    		testFrag.setTest(buffer);
//    		transaction = getFragmentManager().beginTransaction();
//        	transaction.replace(R.id.fragment_content, testFrag);
//        	return;
//		}
		
    	//DataLogger-Fragment Update (+flags in switch_case)
//		if (dataLogFrag != null && dataLogFrag.isVisible()) {
//    		
//        	if (revsflag && speedflag){	
//    			if(!dataflag){
//    				temp_time0 = System.nanoTime();
//    				time += ((temp_time0 - temp_time1)/1000);
//    				dataflag = true;
//    			}
//    			
//    			else if(dataflag){    				
//    				temp_time1 = System.nanoTime();
//    				time += ((temp_time1 - temp_time0)/1000);
//    				dataflag = false;
//				}
//    			
//    			if(firstround){
//    				time = 0;
//    				firstround = false;
//    			}
//				
//				uiCallback.sendEmptyMessage(0);
//
//        		revsflag = false;
//        		speedflag = false;
//			}
//    	}
    	
		switch (id) {
		case ID_REVS:
			int revs = (int) data;
			if (revs >= 0 && revs <= 7000) { //0x3fff is the initial value
				if (tachoFrag != null && tachoFrag.isVisible()) {
	        		tachoFrag.setRevs(revs);
	            	transaction.replace(R.id.fragment_content, tachoFrag);
				}
	        	else if (overviewFrag != null && overviewFrag.isVisible()) {
	        		overviewFrag.setRevs(revs);
	            	transaction.replace(R.id.fragment_content, overviewFrag);
				}
			}
        	break;
		case ID_SPEED:
			
				int speed = (int) data/10 ;
				if (speed >= 0 && speed <= 300) {
					if (tachoFrag != null && tachoFrag.isVisible()) {
						tachoFrag.setSpeed(speed);
		            	transaction.replace(R.id.fragment_content, tachoFrag);
					}
					else if (overviewFrag != null && overviewFrag.isVisible()) {
						overviewFrag.setSpeed(speed);
		            	transaction.replace(R.id.fragment_content, overviewFrag);
					}
				
			
				
			}
			
			break;
		case ID_FUEL:
			int fuel = ((int)data*100)/83; //83l tank capacity
			if (fuel >= 0 && fuel <= 100) { //0xff is the initial value
				if (tachoFrag != null && tachoFrag.isVisible()) {
					tachoFrag.setFuelGauge(fuel);
	            	transaction.replace(R.id.fragment_content, tachoFrag);
				}
				else if (overviewFrag != null && overviewFrag.isVisible()) {
					overviewFrag.setFuelGauge(fuel);
	            	transaction.replace(R.id.fragment_content, overviewFrag);
				}
			}
			break;
		case ID_ENGINE_TEMP:
			double waterTemp = data - 40;
			if (waterTemp >= -40 && waterTemp <=140) {
				if (tachoFrag != null && tachoFrag.isVisible()) {
					tachoFrag.setEngTemp((int) waterTemp);
	            	transaction.replace(R.id.fragment_content, tachoFrag);
				}
				else if (overviewFrag != null && overviewFrag.isVisible()) {
					overviewFrag.setEngTemp(waterTemp);
	            	transaction.replace(R.id.fragment_content, overviewFrag);
				}
			}
			break;
		case ID_MILEAGE:
			long mileage = data/10;
			if (mileage >= 0 && mileage <=1000000) {
				if (tachoFrag != null && tachoFrag.isVisible()) {
					tachoFrag.setMileage(mileage);
	            	transaction.replace(R.id.fragment_content, tachoFrag);
				}
				else if (overviewFrag != null && overviewFrag.isVisible()) {
					overviewFrag.setMileage(mileage);
	            	transaction.replace(R.id.fragment_content, overviewFrag);
				}
			}
			break;
		case ID_OUTDOOR_TEMP:
			double ambientTemp = ((double)data/2) - 40;
			if (ambientTemp >= -40 && ambientTemp <= 60) {
				if (overviewFrag != null && overviewFrag.isVisible()) {
					overviewFrag.setAmbientTemp(ambientTemp);
	            	transaction.replace(R.id.fragment_content, overviewFrag);
				}
			}
			break;
		default:
			break;
		}
    }
    
private void Simulation() 
{	
	ambientTemp = 20;
	engTemp = 20;
	mileage = 123456;
	fuel = 100;
	
	thread = new Thread()
		{				
			public void run()
			{			
				for (int i=0; i<l; i++) 
				{
					try {
						Thread.sleep(99);
		    			} 
					catch (InterruptedException e) 
		    			{
						// TODO Auto-generated catch block
						e.printStackTrace();
		    			}
					
					speed = SPEED[i];
					revs = ENGSPEED[i];
					if(i%20 == 0)
					{
						fuel -= 1;
						engTemp += 0.5;
						if(engTemp>90)
						{
							engTemp=90;
						}
						mileage += 1;
					}
					
					gear = GEAR[i];
					time += 0.1;
					
					uiCallback.sendEmptyMessage(0);
					
					if(i==(l-1))
					{
						speed = 0;
					  	revs = 0;
					  	fuel = 0;
					  	engTemp = 0;
					  	mileage = 0;
					  	ambientTemp = 0;
					  	gear = 0;
					  	time = 0;
					  	uiCallback.sendEmptyMessage(0);
					}
				}
			}
		};
		thread.start();
	}
	
	private Handler uiCallback = new Handler () 
	{
	    public void handleMessage (Message msg) 
	    {
	    	if (D) Log.i(TAG, "run() -> Handler");
	    	
	    	tachoFrag = (Tacho_Fragment) getFragmentManager().findFragmentByTag("Tacho");
			overviewFrag = (Overview_Fragment) getFragmentManager().findFragmentByTag("Overview");
			dataLogFrag = (DataLogger_Fragment) getFragmentManager().findFragmentByTag("DataLogger");
			transaction = getFragmentManager().beginTransaction();
    		
			if (D) Log.i(TAG, "run() -> LogicAnalizerView - transaction.replace(R.id.fragment_content, tachoFrag)");
			if (tachoFrag != null && tachoFrag.isVisible()) 
			{  			
				tachoFrag.setRevs(revs);
				tachoFrag.setSpeed(speed);
				tachoFrag.setFuelGauge(fuel);
				if(engTemp>60)
				{
		        	tachoFrag.setEngTemp(engTemp);
		        }
		        else
		        {
		        	engTemp = 60;
		        	tachoFrag.setEngTemp(engTemp);
		        }
				tachoFrag.setMileage(mileage);
				tachoFrag.setAmbientTemp(ambientTemp);
				tachoFrag.setGear(gear);
				
				transaction.replace(R.id.fragment_content, tachoFrag);
			}
			
			
			if (D) Log.i(TAG, "run() -> LogicAnalizerView - transaction.replace(R.id.fragment_content, overviewFrag)");
			if (overviewFrag != null && overviewFrag.isVisible()) 
			{   
				overviewFrag.setRevs(revs);
				overviewFrag.setSpeed(speed);
				overviewFrag.setFuelGauge(fuel);
				overviewFrag.setEngTemp(engTemp);
				overviewFrag.setMileage(mileage);
				overviewFrag.setAmbientTemp(ambientTemp);
				
				transaction.replace(R.id.fragment_content, overviewFrag);
    		}
            
			if (D) Log.i(TAG, "run() -> LogicAnalizerView - transaction.replace(R.id.fragment_content, dataLogFrag)");
			if (dataLogFrag!=null && dataLogFrag.isVisible()) 
			{            				
				dataLogFrag.setData(time, speed, revs, gear);
				
				transaction.replace(R.id.fragment_content, dataLogFrag);
			}
			  	        
	    }
	    
	};
	
	
}