package de.projektarbeit.fragment;

import de.projektarbeit.can_monitor.R;
import de.projektarbeit.graph.Data;
import de.projektarbeit.graph.MockData;
import android.app.Fragment;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ProgressBar;
import android.widget.TextView;

public class Overview_Fragment extends Fragment {
	
	
	// Get all the TextViews
	View tvSpeed, tvRevs, tvFuel, tvMileage, tvEngineTemp, tvAmbientTemp;
	// and the ProgressBars
	View pbSpeed, pbRevs, pbFuel;
	
	private static final int MAX_SPEED = 260;
	private static final int MAX_REVS = 7000;
	private static final int MAX_FUEL = 100;
	
	private static int SPEED = 0;
	private static int REVS = 0;
	private static int FUEL = 0;
	private static long MILEAGE = 0;
	private static double ENGINE_TEMP = 0;
	private static double AMBIENT_TEMP = 0;
	
	@Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
		// Inflate the layout for this fragment
        View v = inflater.inflate(R.layout.overview_tab_content, container, false);
        setInitialConditions(v);
        return v;
    }

	public void setSpeed(int value) {
    	SPEED = value;
    	Data.Speed v = MockData.getSPEEDfromReceiver(SPEED);
    	((TextView)tvSpeed).setText(Integer.toString(v.getV()) + " km/h");
    	((ProgressBar)pbSpeed).setProgress(v.getV());
    	}
	
	public void setRevs(int value) {
		REVS = value;
		Data.EngSpeed n = MockData.getENGSPEEDfromReceiver(REVS);
		((TextView)tvRevs).setText(Long.toString(n.getN()) + " Upm");
		((ProgressBar)pbRevs).setProgress(n.getN());
    	}
	
	public void setFuelGauge(int value) {
		FUEL = value;
		Data.Fuel fuel = MockData.getFUELfromReceiver(FUEL);
    	((TextView)tvFuel).setText(Integer.toString(fuel.getFUEL()) + " %");
    	((ProgressBar)pbFuel).setProgress(fuel.getFUEL());
    	}
	
	public void setMileage(long value) {
		MILEAGE = value;
		Data.OdoMeter mileage = MockData.getMILEAGEfromReceiver(MILEAGE);
    	((TextView)tvMileage).setText(Long.toString(mileage.getODOMETER()) + " km");
    	}
	
	public void setEngTemp(double value){
		ENGINE_TEMP = value;
		Data.EngTemp engtemp = MockData.getENGTEMPfromReceiver(ENGINE_TEMP);
		((TextView)tvEngineTemp).setText(Double.toString(engtemp.getENGTEMP()) + " C");
	}
	
	public void setAmbientTemp(double value){
		AMBIENT_TEMP = value;
		Data.AmbientTemp ambienttemp = MockData.getAMBIENTTEMPfromReceiver(AMBIENT_TEMP);
		((TextView)tvAmbientTemp).setText(Double.toString(ambienttemp.getAMBIENTTEMP()) + " C");
	}

private void setInitialConditions(View v) {
		
		tvSpeed = v.findViewById(R.id.overviewvalue1);
        ((TextView)tvSpeed).setText(Integer.toString(SPEED) + " km/h");
        pbSpeed = v.findViewById(R.id.overviewProgressBar1);
        ((ProgressBar)pbSpeed).setMax(MAX_SPEED);
        ((ProgressBar)pbSpeed).setProgress(SPEED);
        
        tvRevs = v.findViewById(R.id.overviewvalue2);
        ((TextView)tvRevs).setText(Integer.toString(REVS) + " Upm");
        pbRevs = v.findViewById(R.id.overviewProgressBar2);
        ((ProgressBar)pbRevs).setMax(MAX_REVS);
        ((ProgressBar)pbRevs).setProgress(REVS);
        
        tvFuel = v.findViewById(R.id.overviewvalue3);
        ((TextView)tvFuel).setText(Integer.toString(FUEL) + " %");
        pbFuel = v.findViewById(R.id.overviewProgressBar3);
        ((ProgressBar)pbFuel).setMax(MAX_FUEL);
        ((ProgressBar)pbFuel).setProgress(FUEL);
        
        tvMileage = v.findViewById(R.id.overviewvalue4);
        ((TextView)tvMileage).setText(Long.toString(MILEAGE) + " km");
        
        tvEngineTemp = v.findViewById(R.id.overviewvalue5);
        ((TextView)tvEngineTemp).setText(Double.toString(ENGINE_TEMP) + " C");
        
        tvAmbientTemp = v.findViewById(R.id.overviewvalue6);
        ((TextView)tvAmbientTemp).setText(Double.toString(AMBIENT_TEMP) + " C");
	}

}
