package de.projektarbeit.fragment;

import org.achartengine.GraphicalView;
import de.projektarbeit.can_monitor.R;
import de.projektarbeit.graph.Data;
import de.projektarbeit.graph.EngSpeedGraph;
import de.projektarbeit.graph.EngTempGraph;
import de.projektarbeit.graph.FuelGraph;
import de.projektarbeit.graph.MockData;
import de.projektarbeit.graph.SpeedGraph;
import android.app.Fragment;
import android.graphics.Color;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ProgressBar;
import android.widget.TextView;
public class Tacho_Fragment extends Fragment {
	
	private static GraphicalView viewSPEED;
	private SpeedGraph tacho = new SpeedGraph();
	
	private static GraphicalView viewENGSPEED;
	private EngSpeedGraph rpm = new EngSpeedGraph();
	
	private static GraphicalView viewFUEL;
	private FuelGraph fuel_ = new FuelGraph();
	
	private static GraphicalView viewENGTEMP;
	private EngTempGraph eng_temp = new EngTempGraph();
	
	private static int SPEED = 0;
	private static int REVS = 0;
	private static int FUEL = 0;
	private static double TEMP = 0;
	private static long MILEAGE = 0;
	private static int GEAR = 0;
	private static double AMBIENT_TEMP = 0;
	private static int MAX_REVS = 7000;
	
	//Ziffernbltter
	View speed, engspeed, tank,temp;
		
	//Text
	View tvMileage, tvGear, tvAmbientTemp;
	
	//ProgressBar
	View pbengspeed,pbengspeed2;
		
	private static boolean margin = false;
	
	@Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        // Inflate the layout for this fragment
		
		View v = inflater.inflate(R.layout.tacho_tab_content, container, false);
		setInitialConditions(v, inflater);
				
		return v;
    }
	
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
	}
	
	@Override
	public void onPause (){
		super.onPause();
	}
	
	private void setInitialConditions(View v, LayoutInflater inflater) {
		
		//Speed
		speed = v.findViewById(R.id.speed);
		viewSPEED = tacho.getView(inflater.getContext());
		((ViewGroup) speed).addView(viewSPEED);
				
		//EngSpeed
		engspeed = v.findViewById(R.id.rpm);
		viewENGSPEED = rpm.getView(inflater.getContext());
		((ViewGroup) engspeed).addView(viewENGSPEED);
				
		//Fuel
		tank = v.findViewById(R.id.fuel);
		viewFUEL = fuel_.getView(inflater.getContext());
		((ViewGroup) tank).addView(viewFUEL);
				
		//WaterTemp
		temp = v.findViewById(R.id.wtemp);
		viewENGTEMP = eng_temp.getView(inflater.getContext());
		((ViewGroup) temp).addView(viewENGTEMP);
				
		//OdoMeter
		tvMileage = v.findViewById(R.id.mileage);
		((TextView)tvMileage).setTextColor(Color.BLACK);
		((TextView)tvMileage).setTextSize(15);
		((TextView)tvMileage).setText(Long.toString(MILEAGE));
		      
		//Gear
		tvGear = v.findViewById(R.id.gear);
		((TextView)tvGear).setTextColor(Color.RED);
		((TextView)tvGear).setTextSize(35);
		((TextView)tvGear).setText(Long.toString(GEAR));
		       
		//AmbientTemp
		tvAmbientTemp = v.findViewById(R.id.ambienttemp);
		((TextView)tvAmbientTemp).setTextColor(Color.YELLOW);
		((TextView)tvAmbientTemp).setTextSize(25);
		((TextView)tvAmbientTemp).setText(Double.toString(AMBIENT_TEMP) + " C");
		
		//rpmbar
		pbengspeed = v.findViewById(R.id.progressBar3);
		((ProgressBar)pbengspeed).setMax(MAX_REVS);
		((ProgressBar)pbengspeed).setProgress(REVS);
		pbengspeed2 = v.findViewById(R.id.progressBar4);
		((ProgressBar)pbengspeed2).setMax(MAX_REVS);
		((ProgressBar)pbengspeed2).setProgress(REVS);
	}
	
	public void setSpeed(int value) {
    	SPEED = value;
    	Data.Speed v = MockData.getSPEEDfromReceiver(SPEED);
		tacho.addNewSpeed(v);
		viewSPEED.repaint();
    }
	
	public void setRevs(int value) {
    	REVS = value;
		Data.EngSpeed n = MockData.getENGSPEEDfromReceiver(REVS);
		rpm.addNewEngSpeed(n);
		viewENGSPEED.repaint();
		
		// Update the progress bar
		if(REVS < 6400){
			if(!margin){
				((ProgressBar)pbengspeed2).setVisibility(View.GONE);
				((ProgressBar)pbengspeed).setVisibility(View.VISIBLE);
				margin = true;
			}
			((ProgressBar)pbengspeed).setProgress(n.getN());
		}
		else if(REVS > 6401){
			if(margin){
				((ProgressBar)pbengspeed2).setVisibility(View.VISIBLE);
				((ProgressBar)pbengspeed).setVisibility(View.GONE);
				margin = false;
			}
			((ProgressBar)pbengspeed2).setProgress(n.getN());
		}
	}
	
	public void setFuelGauge(int value) {
		FUEL = value;
		Data.Fuel fuel = MockData.getFUELfromReceiver(FUEL);
		fuel_.addNewFuel(fuel);
		viewFUEL.repaint();
	}

	public void setEngTemp(double value) {
		TEMP = value;
		Data.EngTemp engtemp = MockData.getENGTEMPfromReceiver(TEMP);
		eng_temp.addNewEngTemp(engtemp);
		viewENGTEMP.repaint();
	}

	public void setMileage(long value) {
		MILEAGE = value;
		Data.OdoMeter mileage = MockData.getMILEAGEfromReceiver(MILEAGE);
		((TextView)tvMileage).setText(Long.toString(mileage.getODOMETER()));
	}
	
	public void setAmbientTemp(double value){
		AMBIENT_TEMP = value;
		Data.AmbientTemp ambienttemp = MockData.getAMBIENTTEMPfromReceiver(AMBIENT_TEMP);
		((TextView)tvAmbientTemp).setText(Double.toString(ambienttemp.getAMBIENTTEMP()) + " C");
	}
	
	public void setGear(int value) {
		GEAR = value;
		Data.Gear gear = MockData.getGEARfromReceiver(GEAR);
		((TextView)tvGear).setText(Long.toString(gear.getGEAR()));
	
	}
	
}