package de.projektarbeit.graph;

import org.achartengine.ChartFactory;
import org.achartengine.GraphicalView;
import org.achartengine.model.CategorySeries;
import org.achartengine.renderer.DialRenderer;
import org.achartengine.renderer.SimpleSeriesRenderer;
import org.achartengine.renderer.DialRenderer.Type;


import android.content.Context;
import android.graphics.Color;

public class EngSpeedGraph {
	private GraphicalView viewENGSPEED;
	
	CategorySeries category = new CategorySeries("RPM");
	DialRenderer renderer = new DialRenderer();
	SimpleSeriesRenderer r = new SimpleSeriesRenderer();

	public EngSpeedGraph()
	{
		
		category.add("Drehzahl", 0);
		renderer.setChartTitleTextSize(20);
	    renderer.setLabelsTextSize(15);
	    renderer.setLegendTextSize(15);
	    renderer.setMargins(new int[] { 0,0,0,0 });
	    r.setColor(Color.RED);
	    renderer.addSeriesRenderer(r);
	    renderer.setLabelsTextSize(15);
	    renderer.setLabelsColor(Color.BLACK);
	    renderer.setShowLabels(true);
	    renderer.setVisualTypes(new DialRenderer.Type[] {Type.NEEDLE});
	    renderer.setMinValue(0);
	    renderer.setMaxValue(7000);
	    renderer.setMajorTicksSpacing(1000);
		renderer.setShowLegend(false);
		renderer.setMinorTicksSpacing(200);
		renderer.setAngleMax(120);
		renderer.setAngleMin(330);
		renderer.setPanEnabled(false);
		renderer.setScale((float) 1.25);
		
			 
	
	}
		
	public GraphicalView getView(Context context) 
	{
		
		viewENGSPEED =  ChartFactory.getDialChartView(context, category, renderer);
		return viewENGSPEED;
	}
		
	public void addNewEngSpeed(Data.EngSpeed n) 
	{
		category.set(0,"Drehzahl", n.getN());
	}

	
}
