package de.projektarbeit.graph;

import org.achartengine.ChartFactory;
import org.achartengine.GraphicalView;
import org.achartengine.model.CategorySeries;
import org.achartengine.renderer.DialRenderer;
import org.achartengine.renderer.SimpleSeriesRenderer;
import org.achartengine.renderer.DialRenderer.Type;
import android.content.Context;
import android.graphics.Color;

public class EngTempGraph {
	
	private GraphicalView viewENGTEMP;
	
	CategorySeries category = new CategorySeries("Motortemperatur");
	DialRenderer renderer = new DialRenderer();
	SimpleSeriesRenderer r = new SimpleSeriesRenderer();

	public EngTempGraph()
	{
		 
		category.add("C", 0);
		renderer.setChartTitleTextSize(20);
	    renderer.setLabelsTextSize(12);
	    renderer.setLegendTextSize(15);
	    renderer.setMargins(new int[] { 0,0,0,0 });
	    r.setColor(Color.RED);
	    renderer.addSeriesRenderer(r);
	    renderer.setLabelsColor(Color.BLACK);
	    renderer.setShowLabels(true);
	    renderer.setVisualTypes(new DialRenderer.Type[] {Type.NEEDLE});
	    renderer.setMinValue(60);
	    renderer.setMaxValue(120);
	    renderer.setMajorTicksSpacing(30);
		renderer.setShowLegend(false);
		renderer.setMinorTicksSpacing(5);
		renderer.setAngleMax(151);
		renderer.setAngleMin(31);
		renderer.setPanEnabled(false);
		renderer.setScale((float) 1.175);
		
			 
	
	}
		
	public GraphicalView getView(Context context) 
	{
		
		viewENGTEMP =  ChartFactory.getDialChartView(context, category, renderer);
		return viewENGTEMP;
	}
		
	public void addNewEngTemp(Data.EngTemp engtemp) 
	{
		category.set(0,"Wassertemperatur", engtemp.getENGTEMP());
	}

	
}

