package de.projektarbeit.graph;



import org.achartengine.ChartFactory;
import org.achartengine.GraphicalView;
import org.achartengine.chart.PointStyle;
import org.achartengine.model.XYMultipleSeriesDataset;
import org.achartengine.model.XYSeries;
import org.achartengine.renderer.XYMultipleSeriesRenderer;
import org.achartengine.renderer.XYSeriesRenderer;

import de.projektarbeit.graph.AbstractChart;
import android.content.Context;
import android.graphics.Color;



public class MultiLineGraph extends AbstractChart{
	
	private GraphicalView viewMULTILINE;
	
	XYMultipleSeriesRenderer renderer = new XYMultipleSeriesRenderer(3);
	XYMultipleSeriesDataset dataset = new XYMultipleSeriesDataset();
	
	XYSeries seriesV = new XYSeries("Geschwindigkeit", 0);
	XYSeries  seriesN = new XYSeries("Drehzahl", 1);
	XYSeries seriesG = new XYSeries("Gang", 1);
		
	int[] colors = new int[] { Color.BLUE, Color.YELLOW, Color.RED};
	PointStyle[] styles = new PointStyle[] { PointStyle.POINT, PointStyle.POINT, PointStyle.POINT};
	
	public MultiLineGraph(){
		
		dataset.addSeries(seriesV);
		dataset.addSeries(seriesN);
		dataset.addSeries(seriesG);
						
	    setRenderer(renderer, colors, styles);
	    int length = renderer.getSeriesRendererCount();
	    for (int i = 0; i < length; i++) {
	      XYSeriesRenderer r = (XYSeriesRenderer) renderer.getSeriesRendererAt(i);
	      r.setLineWidth(3f);
	    }
	    
	    setChartSettings(renderer, colors);
	    
	}
		
	
	public GraphicalView getView(Context context) 
	{
		viewMULTILINE =  ChartFactory.getCubeLineChartView(context, dataset, renderer, 0.3f);
		return viewMULTILINE;
	}
	
	public void addNewPoints(Data.Time t, Data.Speed v, Data.EngSpeed n, Data.Gear gear)
	{		 
		seriesV.add(t.getTIME(), v.getV());
		seriesN.add(t.getTIME(), n.getN());
		seriesG.add(t.getTIME(), gear.getGEAR()*1000);
	}	
	
}
