package de.projektarbeit.graph;

import org.achartengine.ChartFactory;
import org.achartengine.GraphicalView;
import org.achartengine.model.CategorySeries;
import org.achartengine.renderer.DialRenderer;
import org.achartengine.renderer.SimpleSeriesRenderer;
import org.achartengine.renderer.DialRenderer.Type;
import android.content.Context;
import android.graphics.Color;

public class SpeedGraph 
{
	private GraphicalView viewSPEED;
		
	CategorySeries category = new CategorySeries("Tacho");
	DialRenderer renderer = new DialRenderer();
	SimpleSeriesRenderer r = new SimpleSeriesRenderer();

	public SpeedGraph()
	{
		category.add("Geschwindigkeit", 0);
		renderer.setChartTitleTextSize(20);
	    renderer.setLabelsTextSize(15);
	    renderer.setLegendTextSize(15);
	    renderer.setMargins(new int[] { 0,0,0,0 });
	    r.setColor(Color.RED);
	    renderer.addSeriesRenderer(r);
	    renderer.setLabelsTextSize(15);
	    renderer.setLabelsColor(Color.BLACK);
	    renderer.setShowLabels(true);
	    renderer.setVisualTypes(new DialRenderer.Type[] {Type.NEEDLE});
	    renderer.setMinValue(0);
	    renderer.setMaxValue(260);
	    renderer.setMajorTicksSpacing(20);
		renderer.setShowLegend(false);
		renderer.setMinorTicksSpacing(10);
		renderer.setAngleMax(130);
		renderer.setAngleMin(320);
		renderer.setPanEnabled(false);
		renderer.setScale((float) 1.25);
		 
	
	}
		
	public GraphicalView getView(Context Tacho_Fragment) 
	{
		viewSPEED =  ChartFactory.getDialChartView(Tacho_Fragment, category, renderer);
		return viewSPEED;
	}
		
	public void addNewSpeed(Data.Speed v)
	{
		category.set(0,"Geschwindigkeit", v.getV());
	}

	
}
